
var AWS = require('aws-sdk');
var request = require('request');
var fs = require('fs');
var zlib = require('zlib');

var config = require('./config');

exports.saveVideo = function(sessionToken, videoFileUrl) {

    // copy video to s3 bucket
    var fileExtension = '.mkv'
    var s3Bucket = config.aws.bucket_name;
    var s3Key = sessionToken + '/' + sessionToken + fileExtension;

    // Load the stream
    var body = fs.createReadStream(videoFileUrl).pipe(zlib.createGzip());
    console.log('stream created');

    // Upload the stream
    var s3obj = new AWS.S3({params: {Bucket: s3Bucket, Key: s3Key}});
    s3obj.upload({Body: body}, function(err, data) {
      if (err) {
          console.log("An error occurred", err);
      }
      console.log("Uploaded the file at", data.Location);
    });

    // TODO: configure https vs http
    var postUrl = 'http://' + config.portal.hostname + '/portal/affdex_x2/experiment/set_facevideo_ready';
    // communicate to portal that the video is ready for processing
    request.post(
        postUrl,
        { form: { sessionToken: sessionToken } },
        function (error, response, body) {
            if (!error && response.statusCode == 200) {
                console.log(body)
            } else {
                console.log(error)
            }
            // TODO: error handling for portal down.  retry?
        }
    );
};